#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

typedef struct vertice     //Diventera' lista ciclica
       {
	double xy[2];
	struct vertice *nextv;	       
       }tvertice;

typedef struct rette     //Diventera' lista semplice
       {
	double a,b,c;
	int segno;
	struct rette *nextr;	       
       }trette;

typedef struct polig      //Diventera' lista semplice
	{
	 tvertice *pver;
	 trette *pret;
	 int numver;
	 struct polig *nextp;
	}tpolig;
	
	
//----------------------------------
//Arctang tra -M_PI e M_PI	
/*	
double mioatan(double y,double x)
{
 if ((x==0) && (y==0)) return(-90);
 if (x==0)
 {
  if (y>0) return(M_PI/2);
  if (y<0) return(-M_PI/2);
 }
 if (y==0)
 {
  if (x>0) return(0);
  if (x<0) return(-M_PI);
 } 
 if (x>0) return(atan(y/x));
 if (x<0) 
 {
  if (y>0) return(atan(y/x)+M_PI);
  if (y<0) return(atan(y/x)-M_PI);  
 } 
}	
*/


//----------------------------------
//Controllo se il vertice era gia' stato inserito

int ContUg(tvertice *iniv2,tvertice *pVer2)
{
 int usc2=1;
 tvertice *paus2;
 int err4=0,contv;

 paus2=iniv2;
 while (usc2)
 {
  if ((paus2->xy[0]==pVer2->xy[0]) && (paus2->xy[1]==pVer2->xy[1]))
  {
   err4=-10;
   usc2=0;
  }
  paus2=paus2->nextv;
  if (paus2==iniv2) usc2=0;
 }
 return(err4);
}


//----------------------------------
//Controllo concavo o convesso

int ContConc(tvertice *iniv3)
{
 tvertice *paus3;
 int usc3=1,err5=0;
 double x1,x2,x3,y1,y2,y3,diffang;
 double ep=0.0000000001;
 int cat=0;
 
 paus3=iniv3; 
 while (usc3)
 {
  x1=paus3->xy[0]; y1=paus3->xy[1];
  x2=paus3->nextv->xy[0]; y2=paus3->nextv->xy[1];
  x3=paus3->nextv->nextv->xy[0]; y3=paus3->nextv->nextv->xy[1];  
  diffang=atan2(y3-y2,x3-x2)-atan2(y2-y1,x2-x1);
  if ((fabs(diffang-(-2*M_PI))<ep) || (fabs(diffang-(-M_PI))<ep) || (fabs(diffang)<ep) || (fabs(diffang-M_PI)<ep) || (fabs(diffang-(2*M_PI))<ep)) return(-12);  
  if (paus3==iniv3) 
  {
   if (((diffang>(-2*M_PI)) && (diffang<(-M_PI))) || ((diffang>0) && (diffang<M_PI))) cat=1;
   if (((diffang>(-M_PI)) && (diffang<0)) || ((diffang>M_PI) && (diffang<2*M_PI))) cat=-1;   
  }
  else
  {
   switch (cat)
   {
    case 1 :
           {
            if (((diffang>(-M_PI)) && (diffang<0)) || ((diffang>M_PI) && (diffang<2*M_PI))) return(-11); 
            break;
           }
    case -1 :
           {
            if (((diffang>(-2*M_PI)) && (diffang<(-M_PI))) || ((diffang>0) && (diffang<M_PI))) return(-11);
            break;
           }           
   }
  } 
  paus3=paus3->nextv;
  if (paus3==iniv3) usc3=0;  
 }
 return(err5);
}


//----------------------------------
//Controllo generale

int Cont(int nver1,tvertice *iniv1,tvertice *pVer1,tvertice *pVerVec1)
{
 int err3=0;
 
 if (nver1!=1) err3=ContUg(iniv1,pVer1);
 if ((nver1>2) && (err3==0))
 {
  pVerVec1->nextv=pVer1;
  pVer1->nextv=iniv1;
  err3=ContConc(iniv1);
  if (err3!=0) 
  {
   pVerVec1->nextv=iniv1;
   pVer1->nextv=NULL;   
  }
 } 
 return(err3);
}


int verifica_ext(char *sNomeFileLetto)
{
 int iInd;
 char sExt[5];

 for(iInd=0;(sNomeFileLetto[iInd]!='\0');iInd++);
 if (iInd<=3) return(-1);
 else
     {
      iInd=iInd-4;
      sExt[0]=sNomeFileLetto[iInd];
      sExt[1]=sNomeFileLetto[iInd+1];
      sExt[2]=sNomeFileLetto[iInd+2];
      sExt[3]=sNomeFileLetto[iInd+3];
      sExt[4]='\0';
      if (strcasecmp(sExt,".pol")==0) return(0);
      else return(-1);
     }
}


int LettFile(char *snum1,FILE **f)

{
 char st[50];
 char saus[2];
 char carlett;
 
 snum1[0]='\0';
 if (feof(*f)) return(-100);
 while (strcmp(snum1,"\0")==0)
 {  
  snum1[0]='\0';
  saus[0]='x';
  saus[1]='\0';
  if (feof(*f)) return(-100);
  fscanf((*f),"%c",&carlett);
  while ((!(feof(*f))) && (carlett!=' ')  && (carlett!=10))
  {
   saus[0]=carlett;
   strcat(snum1,saus);
   fscanf((*f),"%c",&carlett);
  }
 } 
 return(0);  
}


//----------------------------------
//inserimento coordinata

double LeggiCoord(int cdf5,FILE *fpol4)
{
 char snum[50];
 double cf=0;
 int k1=0,errf;
 char errore=1,bpunto=0;
 
 if (cdf5)
 {
  errf=LettFile(snum,&fpol4);
  if (errf==-100) return(-100);
 } 
 else
 { 
  scanf("%s",snum);
  getchar();
 } 
  
 switch (snum[0])
 {
  case 'q'  : //Abort programma
  	   {
  	    return(-1); 
  	   } 
  case 'p' :  //Fine inserimento poligono
  	   {
  	    return(-2); 
  	   } 
 default :   //Inserimento normale
  	   {
  	    while (((snum[k1])!='\0')&&(errore)) 
 		{
		 if (!(((snum[k1]>47)&&(snum[k1]<58))||(snum[k1]=='.'))) errore=0;
		  else 
		   {
		    if(snum[k1]=='.')
		  	 {
		  	  if(bpunto==0)bpunto=1;
		  	  else errore=0;
		  	 }
		   }	 
		  k1++;
		 }
	    if (errore==1)
 		{
  		cf=atof(snum);
  		if (cf>1.0000000001) return(-4);
  		return(cf); 
 		}
 		
 	    return(-3); 
           }
 }

}



//----------------------------------
//inserimento vertice

int LeggiVert(tvertice *pVerLetto,int num2,int cdf4,FILE *fpol4) 
{
 double val=0; 
 char dec1;
 int k2,k3;
 
  
 dec1=0;
 while(dec1!=10)
 {
   k2=0;
   if (!cdf4) printf("\n");
   while(k2<2)
    {
     if (!cdf4) 
     {
      if (k2==1) printf("Y%d : ",num2);
      else printf("X%d : ",num2);
     } 
     val=LeggiCoord(cdf4,fpol4);
     
     switch ((int)val)
     {
      case -1 : return(-1);  //Abort programma
      case -2 : return(-2);  //Fine inserimento poligono
      case -100 : return(-100); //Fine file
      case -3 :              //Stringa non corretta
                {
                 if (cdf4) 
                 {
                  printf("\nFormato del file non corretto: e' stato inserito un carattere non valido\n");
                  return(-1);
                 }
                 else
                 {
      		  k2--;
                  printf("\nE' stato inserito un carattere non valido\n");      		  
      		  break;
      		 } 
      		} 
      case -4 :              //Valore >1
                {
                 if (cdf4) 
                 {
                  printf("\nFormato del file non corretto: il valore numerico e' maggiore di uno\n");
                  return(-1);
                 }
                 else
                 {                
         	  k2--;
                  printf("\nIl valore numerico e' maggiore di uno\n");         	  
       		  break;
      		 }
      		} 

      default :              //Inserimento valido
                 {
                  pVerLetto->xy[k2]=val;
                  break;
                 }
     
     }
     k2++;
    }
   if (!cdf4)
   {
    printf ("\nInvio per continuare l'inserimento,\nqualsiasi altro tasto per reinserire il punto %d ",num2);
    dec1=getchar();
    k3=0;
    /*while (dec1=='.') 
    {
     k3=1;
     dec1=getchar();
    }*/
    
    while (dec1!=10) 
    {
     k3=1;
     dec1=getchar();
    }
    
    if (k3==1) dec1='a';   //la 'a' serve perche' altrimenti '......'+invio e' uscita valida
   }
   else
   {
    dec1=10;
   }
 }
 return(0);
}




//----------------------------------
//inserimento vertici di un poligono

int LeggiPol (tpolig *lPol,int num3,int cdf3,FILE *fpol3)
{
 int err=0;
 tvertice *pVer,*pVerVec,*iniv;
 
 
 pVerVec=NULL;
 if (!cdf3) printf("Inserire i vertici del poligono numero %d ",num3);
 pVer=(tvertice *)malloc(sizeof(tvertice));
 if (pVer==NULL) return(-1000); 
 iniv=pVer;
 pVer->nextv=iniv;
 lPol->numver=0;
  
 while ((err!=-1) && (err!=-2) && (err!=-100))
 {
  if (lPol->numver!=0)
  {
   pVer=(tvertice *)malloc(sizeof(tvertice));
   if (pVer==NULL) return(-1000); 
  } 
  err=LeggiVert(pVer,(lPol->numver)+1,cdf3,fpol3);
  switch (err)
  {
   case -1 : return(-1);  //Abort programma
   case -100 :            //Fine file
              {
              if(lPol->numver<3)
               {
                printf("\n Errore ! : Numero di vertici del poligono inferiore a 3\n");
                return(-1);
               } 
               lPol->pver=iniv;              
               return(-100);
              }    
   case -2 :              //Fine inserimento poligono
             {
              if(lPol->numver<3)
              {
               printf("\n Errore ! : Numero di vertici del poligono inferiore a 3\n");
               if (cdf3) return(-1);
               err=0;
               break;
              } 
              lPol->pver=iniv;
              return(-2);
             }
              
   default :             //Inserimento valido
             {
              switch (Cont((lPol->numver)+1,iniv,pVer,pVerVec)) 
              {
               case -10 :               //Vertice gia' inserito in precedenza
                        {
                         printf("\n Errore ! : Il vertice e' gia' stato inserito");
                         if (cdf3) return(-1);
                         free(pVer);
                         break;
                        }
               case -11 :               //Poligono concavo
                        {
                         printf("\n Errore ! : Il poligono risultante sara' concavo"); 
                         if (cdf3) return(-1);
                         free(pVer);
                         break;
                        }
               case -12 :               //Vertici allineati
                        {
                         printf("\n Errore ! : Ci sono tre vertici allineati");
                         if (cdf3) return(-1);
                         free(pVer);
                         break;
                        }         
               default  :               //Vertice valido
                        {
               		 if ((lPol->numver)!=0) 
		         {
                	  pVerVec->nextv=pVer;
	                  pVer->nextv=iniv;
               	         }
	                 (lPol->numver)++;
	                 pVerVec=pVer;
                         break;
                        }
              }
             }
  }
 }
  
}  



//----------------------------------
//inserimento poligoni

int InsPol(tpolig **pPol,int *num1,int cdf2,FILE *fpol2)
{
 int k42,err=0;
 tpolig *pPolVec,*inip;
 char dec72[50],dec=0;
 
 
 (*pPol)=(tpolig *)malloc(sizeof(tpolig));
 if ((*pPol)==NULL) return(-1000);
 (*pPol)->nextp=NULL;
 inip=(*pPol);
   
 while ((err!=-1) && (dec!='n'))
 { 
  dec=0;
  if ((*num1)!=0)
  {
   (*pPol)=(tpolig *)malloc(sizeof(tpolig));
   if ((*pPol)==NULL) return(-1000);   
  } 
  err=LeggiPol((*pPol),(*num1)+1,cdf2,fpol2);
  switch (err)
  {
   case -1000 : return(-1000);  //Memoria insufficiente
   case -1 : return(-1);   //Abort Programma
   case -100 :             //Fine file
              {
               if ((*num1)!=0) 
               {
                pPolVec->nextp=(*pPol);
                (*pPol)->nextp=NULL;
               }                          
               (*num1)++;
               pPolVec=(*pPol);              
               (*pPol)=inip;
               return(0);              
              }
   case -2 :               //Fine inserimento poligono
             {
              if (!cdf2)
              {
               k42=0;
               while ((dec!='s') && (dec!='S') && (dec!='n') && (dec!='N')) 
                {
                 if (k42>0) printf("\nE' stato inserito un carattere non valido.\n");
                 printf("\nSi desidera inserire un altro poligono? (s/n) ");
                 scanf("%s",dec72);
                 getchar();
                 dec=dec72[0];
                 k42++;
                } 
               printf("\n"); 
              } 
              if ((*num1)!=0) 
              {
               pPolVec->nextp=(*pPol);
               (*pPol)->nextp=NULL;
              }
              (*num1)++;
              pPolVec=(*pPol);
              if (!cdf2)
              {
               if (dec=='n') 
               {
                (*pPol)=inip;
                return(0);
               } 
              } 
              break;
             }
  }
 }

}


//----------------------------------
//Visualizzazione poligoni

int VisPol(tpolig *pPolig2,int npol1)
{
 int usc7,contv=0,contp=0;
 tvertice *pveraus1;
 trette *pretaus1;
 
 printf("\nIl numero di poligoni inseriti e' %d\n",npol1); 
 while (pPolig2!=NULL)
 {
  contv=0;
  contp++;
  pveraus1=pPolig2->pver;
  pretaus1=pPolig2->pret;
  printf("\nIl poligono numero %d ha %d vertici\n",contp,pPolig2->numver);
  usc7=1;
  while (usc7)
  {
   contv++;
   printf("X%d=%.6lf ; Y%d=%.6lf ; Retta%d : (%.3lf)X+(%.3lf)Y+(%.3lf)=0\n",
          contv,pveraus1->xy[0],contv,pveraus1->xy[1],contv,pretaus1->a,pretaus1->b,pretaus1->c);
   pveraus1=pveraus1->nextv;
   pretaus1=pretaus1->nextr;
   if (pveraus1==pPolig2->pver) usc7=0;
  } 
  pPolig2=pPolig2->nextp;
 } 
} 



//----------------------------------
//Principale per inserimento

int InsDiretto (tpolig **IniPol1,int *ntotpol,int cdf1,FILE *fpol1)
{
 tpolig *pPolig;
 int numpol=0;
 tvertice *pveraus;
 int contv=0,contp=0;
 int errore=0,usc;

 errore=InsPol(&pPolig,&numpol,cdf1,fpol1);
 (*IniPol1)=pPolig;
 
 switch (errore)
 {
  case -1000 : return(-1000);  //Memoria insufficiente
  case -1 : return(-1);        //Abort del programma
  default :
          {
           break;
          } 
 }
 (*ntotpol)=numpol;
 return(0);
} 


//----------------------------------
//Calcolo delle rette: a,b,c,segno

int Rette(tpolig *pPol1)
{
 int usc6,numr1=0;
 double x1,x2,y1,y2;
 tvertice *paus6,*paus7;
 trette *pRet,*pRetVec=NULL;
 
 while ((pPol1)!=NULL)
 {
  numr1=0;
  pRet=(trette *)malloc(sizeof(trette));
  if (pRet==NULL) return(-1000);
  pRet->nextr=NULL;
  (pPol1)->pret=pRet;
  paus6=(pPol1)->pver; 
  usc6=1;
  while (usc6)
  {
   if (numr1!=0)
   {
    pRet=(trette *)malloc(sizeof(trette));
    if (pRet==NULL) return(-1000);   
   } 
   x1=paus6->xy[0]; y1=paus6->xy[1];
   x2=paus6->nextv->xy[0]; y2=paus6->nextv->xy[1];
   paus7=paus6->nextv->nextv;
   if (x1!=x2)
   {
    pRet->a=y1-y2;
    pRet->b=x2-x1;  
    pRet->c=x1*y2-y1*x2;
   } 
   else
   {
    pRet->a=1;
    pRet->b=0;  
    pRet->c=-x1;    
   }
   if (((pRet->a)*(paus7->xy[0])+(pRet->b)*(paus7->xy[1])+(pRet->c))>0) pRet->segno=1;
   else pRet->segno=-1;
   if (numr1!=0) 
   {
    pRetVec->nextr=pRet;
    pRet->nextr=NULL;
   }
   numr1++;
   pRetVec=pRet;               
   paus6=paus6->nextv;
   if (paus6==(pPol1)->pver) usc6=0;  
  }
  (pPol1)=(pPol1)->nextp;
 }
 return(0);
}


//----------------------------------
//Scrittura del training set su file

int Train(char sme,int puntix,int puntiy,tpolig *pPol6,int npol2,char *SName,char *MName)
{
 double k10=0,k20=0,k30=0,k40=0,valoriy[100];
 int k1=0,k2=0,k3,k4,esito,fuori,esci=0,finale;
 long int contpti,contpti1,conta;
 char *afuori;
 tpolig *pPol5;
 trette *pret5;
 char STrainFile[50],MTrainFile[50],*adentro,esito1,esci2;
 time_t t;
 FILE *fS,*fM;
 double circa1=1.0000000001,circa0=0.0000000001;

 /* allocazione dinamica dei vettori*/
 afuori=(char *)calloc(((int)(puntix*puntiy)),sizeof(char));
 if(afuori==NULL)return(-1);
  
 if ((sme=='s') || (sme=='S') || (sme=='e') || (sme=='E'))
 {
  printf("\nInserire il nome del file del train set per SNNS (senza estensione): ");
  scanf("%s",STrainFile);
  getchar();
  strcpy(SName,STrainFile);
  strcat(STrainFile,".pat");
  fS=fopen(STrainFile,"w");

  time(&t);
  fprintf(fS,"SNNS pattern definition file V1.4\n");
  fprintf(fS,"generated at %s\n\n", ctime( &t));
  fprintf(fS,"No. of patterns : %d\n",(int)(puntix*puntiy));
  fprintf(fS,"No. of input units : 2\n");
  fprintf(fS,"No. of output units : %d\n\n",npol2+1); 
  
  for (k10=0; k10<=circa1; k10=k10+1/(((double)puntix)-1))
   {
    for (k20=0; k20<=circa1; k20=k20+1/(((double)puntiy)-1))
     {
      fprintf(fS,"%lf %lf  ",k10,k20);
      fuori=1;
      pPol5=pPol6;
      while (pPol5!=NULL)
      {
       esito=1;
       pret5=pPol5->pret;
       while ((pret5!=NULL) && (esito))
       {
       if (((((pret5->a)*k10+(pret5->b)*k20+(pret5->c))-circa0>0) && (pret5->segno==-1)) ||
           ((((pret5->a)*k10+(pret5->b)*k20+(pret5->c))+circa0<0) && (pret5->segno==1))) esito=0;
       pret5=pret5->nextr;
       }
       if (esito==1) fuori=0;
       fprintf(fS,"%d ",esito);
       pPol5=pPol5->nextp;
      }
      fprintf(fS,"%d\n",fuori);
     }
   }
  fclose(fS); 
 }
 if ((sme=='m') || (sme=='M') || (sme=='e') || (sme=='E'))
 {
  printf("\nInserire il nome del file del train set per MATLAB (senza estensione): ");
  scanf("%s",MTrainFile);
  getchar();
  strcpy(MName,MTrainFile);
  strcat(MTrainFile,".m");
  fM=fopen(MTrainFile,"w");

  time(&t);
  fprintf(fM,"%% Matlab pattern definition file V5.2\n");
  fprintf(fM,"%% generated at %s%% \n%% \n", ctime( &t));
  fprintf(fM,"%% No. of patterns : %d\n",(int)(puntix*puntiy));
  fprintf(fM,"%% No. of input units : 2\n");
  fprintf(fM,"%% No. of output units : %d\n\n",npol2+1);
  
  contpti=0;
  contpti1=0;
  k10=0;
  k20=0;
  k30=0;
  k40=0;
  while((k10<=circa1)||(k20<=circa1))
   {
    if(contpti1==0)
	{
	 fprintf(fM,"P%d = [",(((int)(contpti/100))+1));
	 esci=0;
	}
    for (k10=k30; (k10<=circa1)&&(esci!=1); k10=k10+1/(((double)puntix)-1))
    {
     if(k40>0) /*completa i punti y interrotti */
       {
	for(k20=k40; (k20<=circa1)&&(esci!=1); k20=k20+1/(((double)puntiy)-1))
	  {
   	   if((contpti1==99)&&(contpti>0)) esci=1;
	   if(k20>circa1) k20=2;
	   afuori[contpti]=1;
	   contpti++;
	   fprintf(fM,"%lf ",k10);
	   valoriy[contpti1]=k20;
	   contpti1++;
	  }
	k40=0;
       }
     else
       {
	for (k20=k40; (k20<=circa1)&&(esci!=1); k20=k20+1/(((double)puntiy)-1))
	 {
	  if((contpti1==99)&&(contpti>0)) esci=1;
	  afuori[contpti]=1;
	  contpti++;
	  fprintf(fM,"%lf ",k10);
	  valoriy[contpti1]=k20;
	  contpti1++;
	 }
       }
       
    }
    if(contpti1==100)
	{
	 k30=k10-1/(((double)puntix)-1);
	 /* Diminuisce perche' dopo che e' stato settato esci=1 viene fatto un ciclo in piu' esterno*/
	 k40=k20;
	}
    if(((int)(contpti/100))>=10)fprintf(fM,";\n       ");
    else fprintf(fM,";\n      ");
    for(conta=0;conta<contpti1;conta++)
       {
	fprintf(fM,"%lf ",valoriy[conta]);
       }
    fprintf(fM,"];\n\n");
    esci=0;
    contpti1=0;
   }
  k1=1;
  k4=1;
  fprintf(fM,"PA%d=[",k1);
  k3=0;
  if (contpti%100==0) finale=(((int)(contpti/100))); 
  else finale=(((int)(contpti/100))+1);
  while (k3<=finale-1)
  {
     for(k3=k4;((k3-k4)<200)&&(k3<=finale);k3++)
       {
        if ((k3-1)%200==0) fprintf(fM,"P%d",k3);
        else fprintf(fM,",P%d",k3);
       }
     k4=k3; 
     if (k3<=finale) 
     {
      k1++;
      fprintf(fM,"];\n\n");
      fprintf(fM,"PA%d=[",k1);
     }
  }  
  fprintf(fM,"];\n\n");
  
  fprintf(fM,"P=[PA1");
  if((contpti%100)!=0)
    {
     for(k3=2;k3<(k1+1);k3++)
       {
	fprintf(fM,",PA%d",k3);
       }
    }
  else

    {
     for(k3=2;k3<=k1;k3++)
       {
	fprintf(fM,",PA%d",k3);
       }
    }
  fprintf(fM,"];\n\n");  
  
  
  //scrittura target
  k10=0;
  k20=0;
  pPol5=pPol6;

  /*allocazione dinamica del vettore delle uscite obiettivo*/
  adentro=(char *)calloc((npol2*(((int)(puntix*puntiy)))),sizeof(char));
  if(adentro==NULL)return(-1);

  /*calcolo delle uscite obiettivo*/
  pPol5=pPol6;
  k3=0;
  while (pPol5!=NULL)
  {
   contpti=0;
   for (k10=0; k10<=circa1; k10=k10+1/(((double)puntix)-1))
   {
    for (k20=0; k20<=circa1; k20=k20+1/(((double)puntiy)-1))
    {
     esito1=1;
     pret5=pPol5->pret;
     while ((pret5!=NULL) && (esito1))
     {
      if (((((pret5->a)*k10+(pret5->b)*k20+(pret5->c))-circa0>0) && (pret5->segno==-1)) ||
	 ((((pret5->a)*k10+(pret5->b)*k20+(pret5->c))+circa0<0) && (pret5->segno==1))) esito1=0;
      pret5=pret5->nextr;
     }
     if (esito1==1) afuori[contpti]=0;
     adentro[((k3*((puntix*puntiy)-1))+contpti)]=esito1;
     contpti++;
    }
   }
   pPol5=pPol5->nextp;
   k3++;
  }
  /*salvataggio su file del vettore delle uscite obiettivo decomposto in vettori di 100 elementi*/
  k1=0;
  k2=0;
  k3=0;
  while(k2<(puntix*puntiy))
   {
    if((k2%100)==0)fprintf(fM,"T%d = [",((int)(k2/100))+1);
    for(k1=0;k1<npol2;k1++)
     {
      for(k2=k3;((k2<((puntix*puntiy)))&&((k2-k3)<100));k2++)
       {
	fprintf(fM,"%d ",adentro[k2+(k1*((puntix*puntiy)-1))]);
       }
      if(((int)(k2/100))>=10)fprintf(fM,";\n       ");
      else fprintf(fM,";\n      ");
     }
    for (k1=k3; (k1<((puntix*puntiy)))&&((k1-k3)<100); k1++)
     {
      fprintf(fM,"%d ",afuori[k1]);
     }
    fprintf(fM,"];\n");
    k3=k2;

   }
 
   
  k1=1;
  k4=1;
  fprintf(fM,"\nTA%d=[",k1);
  k3=0;
  if (k2%100==0) finale=(((int)(k2/100))); 
  else finale=(((int)(k2/100))+1);
  while (k3<=finale-1)
  {
     for(k3=k4;((k3-k4)<200)&&(k3<=finale);k3++)
       {
        if ((k3-1)%200==0) fprintf(fM,"T%d",k3);
        else fprintf(fM,",T%d",k3);
       }
     k4=k3;
     if (k3<=finale) 
     {
      k1++;      
      fprintf(fM,"];\n\n");
      fprintf(fM,"TA%d=[",k1);
     }
  }  
  fprintf(fM,"];\n\n");
  
  fprintf(fM,"T=[TA1");
  if((contpti%100)!=0)
    {
     for(k3=2;k3<k1+1;k3++)
       {
	fprintf(fM,",TA%d",k3);
       }
    }
  else

    {
     for(k3=2;k3<=k1;k3++)
       {
	fprintf(fM,",TA%d",k3);
       }
    }
  fprintf(fM,"];");  

  fclose(fM);
 }  
 return(0);
}


//----------------------------------
//Scrittura del test set su file

int Test(char sme,int px7,int py7,double perc7,tpolig *pPol7,int npol7,char *SName,char *MName)
{
 char fuori,esito;
 int k30;
 long int k1,k2,k3,k4,finale;
 long int fine=((long int)(px7*py7*perc7)+1);
 char *afuori; 
 long int contpti;
 double *x,*y;
 tpolig *pPol5;
 trette *pret5; 
 char STestFile[50],MTestFile[50];
 time_t t;
 FILE *fS,*fM;
 double circa0=0.0000000001;

 if (fine>1) fine--;
 
 /* allocazione dinamica dei vettori*/
 afuori=(char *)calloc(fine,sizeof(char));
 if(afuori==NULL) return(-1);
 x=(double *)calloc(fine,sizeof(double));
 if(x==NULL) return(-1);
 y=(double *)calloc(fine,sizeof(double));
 if(y==NULL) return(-1);

 srand((int)time(&t));
 for (k1=0; k1<fine; k1++)
  { 
   x[k1]=rand()/(RAND_MAX+1.0);
   y[k1]=rand()/(RAND_MAX+1.0); 
  } 
 if ((sme=='s') || (sme=='S') || (sme=='e') || (sme=='E'))
 { 
  printf("\nInserire il nome del file del test set per SNNS (senza estensione): ");
  STestFile[0]='\0';
  k30=0;
  while (!(strcmp(STestFile,"\0")) || !(strcmp(STestFile,SName)))
  {
   if (k30>0) printf("\nNome file gia' usato per il train set. Inserirne un altro: ");
   scanf("%s",STestFile);
   getchar();       
   k30++;
  }
  strcat(STestFile,".pat");
  fS=fopen(STestFile,"w");
 
  time(&t);
  fprintf(fS,"SNNS pattern definition file V1.4\n");
  fprintf(fS,"generated at %s\n\n", ctime( &t));
  fprintf(fS,"No. of patterns : %d\n",fine);
  fprintf(fS,"No. of input units : 2\n");
  fprintf(fS,"No. of output units : %d\n\n",npol7+1); 
 
  for (k1=0; k1<fine; k1++)
   { 
    fprintf(fS,"%lf %lf  ",x[k1],y[k1]);
    fuori=1;
    pPol5=pPol7;
    while (pPol5!=NULL)
    {
     esito=1;
     pret5=pPol5->pret;
     while ((pret5!=NULL) && (esito))
     {
     if (((((pret5->a)*x[k1]+(pret5->b)*y[k1]+(pret5->c))-circa0>0) && (pret5->segno==-1)) ||
         ((((pret5->a)*x[k1]+(pret5->b)*y[k1]+(pret5->c))+circa0<0) && (pret5->segno==1))) esito=0;
     pret5=pret5->nextr;
     }
     if (esito==1) fuori=0;
     fprintf(fS,"%d ",esito);
     pPol5=pPol5->nextp;
    }
    fprintf(fS,"%d\n",fuori);
   }
  fclose(fS); 
 }
 
 if ((sme=='m') || (sme=='M') || (sme=='e') || (sme=='E'))
 {
  printf("\nInserire il nome del file del test set per MATLAB (senza estensione): ");
  MTestFile[0]='\0';
  k30=0;
  while (!(strcmp(MTestFile,"\0")) || !(strcmp(MTestFile,MName)))
  {
   if (k30>0) printf("\nNome file gia' usato per il train set. Inserirne un altro: ");
   scanf("%s",MTestFile);
   getchar();       
   k30++;
  }
  strcat(MTestFile,".m");
  fM=fopen(MTestFile,"w");

  time(&t);
  fprintf(fM,"%% Matlab pattern definition file V5.2\n");
  fprintf(fM,"%% generated at %s%% \n%% \n", ctime( &t));
  fprintf(fM,"%% No. of patterns : %d\n",fine);
  fprintf(fM,"%% No. of input units : 2\n");
  fprintf(fM,"%% No. of output units : %d\n\n",npol7+1);

  k1=0;
  k2=0;
  k3=0;
  contpti=0;
  fprintf(fM,"P1 = [");
  while((k2<fine)||(k3<fine))
   {
    if(((k1%100)==0)&&(contpti>0))fprintf(fM,"P%d = [",((int)(k1/100))+1);
    for (k1=k2; (k1<fine)&&((k1-k2)<100); k1++)
     {
      afuori[k1]=1;
      fprintf(fM,"%lf ",x[k1]);
      contpti++;
     }
    if(((int)(contpti/100))>=10)fprintf(fM,";\n       ");
    else fprintf(fM,";\n      ");
    k2=k1;
    for (k1=k3; (k1<fine)&&((k1-k3)<100); k1++)
     {
      fprintf(fM,"%lf ",y[k1]);
     }
    fprintf(fM,"];\n\n");
    k3=k1;
   }


  k1=1;
  k2=1;
  fprintf(fM,"PA%d=[",k1);
  k3=0;
  if (contpti%100==0) finale=(((int)(contpti/100))); 
  else finale=(((int)(contpti/100))+1);
  while (k3<=finale-1)
  {
     for(k3=k2;((k3-k2)<200)&&(k3<=finale);k3++)
       {
        if ((k3-1)%200==0) fprintf(fM,"P%d",k3);
        else fprintf(fM,",P%d",k3);
       }
     k2=k3;
     if (k3<=finale) 
     {
      k1++;
      fprintf(fM,"];\n\n");
      fprintf(fM,"PA%d=[",k1);
     }
  }  
  fprintf(fM,"];\n\n");
  
  fprintf(fM,"tst.P=[PA1");
  if((contpti%100)!=0)
    {
     for(k3=2;k3<k1+1;k3++)
       {
	fprintf(fM,",PA%d",k3);
       }
    }
  else

    {
     for(k3=2;k3<=k1;k3++)
       {
	fprintf(fM,",PA%d",k3);
       }
    }
  fprintf(fM,"];\n\n");  
  
  k1=0;
  k2=0;
  k3=0;
  contpti=0;
  fprintf(fM,"\nT1 = [");
  while((k2<fine)||(k3<fine))
   {
    if(((k1%100)==0)&&(contpti>0))fprintf(fM,"T%d = [",((int)(k1/100))+1);
    pPol5=pPol7;
    while (pPol5!=NULL)
     {
      for (k1=k2; (k1<fine)&&((k1-k2)<100); k1++)
       {
	esito=1;
	pret5=pPol5->pret;
	while ((pret5!=NULL) && (esito))
	 {
	  if (((((pret5->a)*x[k1]+(pret5->b)*y[k1]+(pret5->c))-circa0>0) && (pret5->segno==-1)) ||
	      ((((pret5->a)*x[k1]+(pret5->b)*y[k1]+(pret5->c))+circa0<0) && (pret5->segno==1))) esito=0;
	  pret5=pret5->nextr;
	 }
	if (esito==1) afuori[k1]=0;
	fprintf(fM,"%d ",esito);
       }
      pPol5=pPol5->nextp;
      if(((int)(contpti/100))>=10)fprintf(fM,";\n       ");
      else fprintf(fM,";\n      ");
     }
    k2=k1;
    
   contpti=k1; //contpti = totale punti scritti nel file
   
    for (k1=k3; (k1<fine)&&((k1-k3)<100); k1++)
     {
      fprintf(fM,"%d ",afuori[k1]);
     }
    fprintf(fM,"];\n\n");
    k3=k1;
   }


  k1=1;
  k4=1;
  fprintf(fM,"TA%d=[",k1);
  k3=0;
  if (contpti%100==0) finale=(((int)(contpti/100))); 
  else finale=(((int)(contpti/100))+1);
  while (k3<=finale-1)
  {
     for(k3=k4;((k3-k4)<200)&&(k3<=finale);k3++)
       {
        if ((k3-1)%200==0) fprintf(fM,"T%d",k3);
        else fprintf(fM,",T%d",k3);
       }
     k4=k3;
     if (k3<=finale) 
     {
      k1++;      
      fprintf(fM,"];\n\n");
      fprintf(fM,"TA%d=[",k1);
     }
  }  
  fprintf(fM,"];\n\n");
  
  fprintf(fM,"tst.T=[TA1");
  if((contpti%100)!=0)
    {
     for(k3=2;k3<k1+1;k3++)
       {
	fprintf(fM,",TA%d",k3);
       }
    }
  else

    {
     for(k3=2;k3<=k1;k3++)
       {
	fprintf(fM,",TA%d",k3);
       }
    }
  fprintf(fM,"];");  

  fclose(fM);
 }
 return(0);  
}


//----------------------------------
//MAIN

int main (void)

{
 char sp[50],dec71[50],cambio=0,dec7=0,snns_mat=0,uscita=0;
 int cdf=0,px=0,py=0;
 tpolig *IniPol;
 int npol,err10=-1,err11=-1,k41;
 FILE *fpol=NULL;
 char st[50],SContName[50],MContName[50];
 double perc=0;
 
 printf("Questo programma consente di generare piu' poligoni di\n");
 printf("'qualsiasi' dimensione al fine di creare dei file per\n");
 printf("l'addestramento e la fase di testing di reti neurali.\n");
 printf("Si hanno due possibilita':");
 
 while ((uscita!='n') && (uscita!='N')) 
 {
  printf("\n");
  printf("1) Premere 'D' per inserire i poligoni direttamente;\n");
  printf("2) Premere 'C' per caricarli da file.\n");

  k41=0;
  cambio=0;
  while ((cambio!='D') && (cambio!='d') && (cambio!='C') && (cambio!='c') && (cambio!='Q') && (cambio!='q'))
  {
   if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
   printf("\nRisposta : ");
   scanf("%s",dec71);
   getchar();
   cambio=dec71[0];
   k41++;  
  }
  if ((cambio=='Q') || (cambio=='q')) 
  {
   printf("\nProgramma abortito!\n");
   exit(-1);
  } 
  if ((cambio=='C') || (cambio=='c')) cdf=1; else cdf=0;  

  switch (cdf)
  {
   case 0 :
            {
             printf("\nE' consentito l'inserimento di poligoni convessi e non concavi\n");
             printf("all'interno di un quadrato tra 0 e 1 (lungo le X e le Y).\n");
             printf("Durante l'inserimento dei punti e' consentito inserire uno\n");
             printf("dei seguenti caratteri:\n");
             printf("1) le cifre da 0 a 9;\n");
             printf("2) '.': come virgola per i decimali;\n");
             printf("3) 'p': per terminare l'inserimento di un poligono;\n");
             printf("4) 'q': per uscire dal programma;\n");            
             printf("\nQualsiasi altro carattere generera' un errore.\n\n");
             break;
            } 
   case 1 :
            {
             printf("\nInserire il file dei poligoni (deve avere estensione .pol): ");
             scanf("%s",st); 
             getchar();
             fpol=fopen(st,"r");
             if (fpol==NULL)
             {
              printf("\nIl file non esiste e/o errore nella lettura\n");
              printf("\nProgramma abortito!\n");
              exit(-21);            
             }
             if (verifica_ext(st)!=0) 
             {
              printf("\nL'estensione del file non e' corretta\n");
              printf("\nProgramma abortito!\n");
              exit(-20);
             }
            }         
  }  

  err10=InsDiretto(&IniPol,&npol,cdf,fpol);
 
  if (cdf==1) fclose(fpol);
 
  switch (err10)
  {
   case -1000 :
            {
             printf("\nProgramma abortito! Memoria insufficiente\n");
             exit(-1);
            }
   case -1 :
           {
            printf("\nProgramma abortito!\n");
            exit(-1);
           }
   default :
           {
            Rette(IniPol);
            VisPol(IniPol,npol);
            px=0;
            while (px<2)
            {
             printf("\nInserire i punti lungo l'asse X (almeno 2): ");
             scanf("%s",sp);
             px=atoi(sp);
             if (px<2) printf("\nErrore ! : Valore inserito non corretto\n");
             getchar();
            }
            printf("\nSono stati inseriti %d punti lungo l'asse X\n",px);
            py=0;
            while (py<2)
            {
             printf("\nInserire i punti lungo l'asse Y (almeno 2): ");
             scanf("%s",sp);
             py=atoi(sp);
             if (py<2) printf("\nErrore ! : Valore inserito non corretto\n");
             getchar();
            }           
            printf("\nSono stati inseriti %d punti lungo l'asse Y\n",py);           
            k41=0;
            while ((snns_mat!='s') && (snns_mat!='S') && (snns_mat!='m') && 
                   (snns_mat!='M') && (snns_mat!='e') && (snns_mat!='E'))
                   {
                    if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
                    printf("\nI file serviranno per SNNS, Matlab o per entrambi? (s,m,e): ");
                    scanf("%s",dec71);
                    getchar();
                    snns_mat=dec71[0];
                    k41++;
                   } 
           
            dec7=0;
            k41=0;
            while ((dec7!='s') && (dec7!='S') && (dec7!='n') && (dec7!='N')) 
             {
              if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
              printf("\nSi desidera creare il file per il train set? (s/n) ");
              scanf("%s",dec71);
              getchar();
              dec7=dec71[0];
              k41++;
             } 
            if ((dec7=='s') || (dec7=='S')) 
            {
             err11=Train(snns_mat,px,py,IniPol,npol,SContName,MContName);
             if (err11<0) 
              {
               printf("\nProgramma abortito! Memoria insufficiente\n");
               exit(-1);
              }
            }
            dec7=0;
            k41=0;
            while ((dec7!='s') && (dec7!='S') && (dec7!='n') && (dec7!='N')) 
            {
              if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
               printf("\nSi desidera creare il file per il test set? (s/n) ");
              scanf("%s",dec71);
              getchar();
              dec7=dec71[0];
              k41++;
             } 
            
            if ((dec7=='s') || (dec7=='S')) 
            {
             k41=0;
             perc=0;
             while ((perc<=0) || (perc>1))
             {
              if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
              printf("\nInserire la percentuale di punti del test set, nell'intervallo (0,1]: ");
              scanf("%s",sp);
              getchar();
              perc=atof(sp);
              k41++;       
             }  
             if ((int)(px*py*perc)==0) printf("\nIl test set sara' costituito da %d pattern\n",(int)(px*py*perc)+1);
             else printf("\nIl test set sara' costituito da %d pattern\n",(int)(px*py*perc));
             err11=Test(snns_mat,px,py,perc,IniPol,npol,SContName,MContName);    
             if (err11<0) 
              {
               printf("\n\nProgramma abortito! Memoria insufficiente\n");
               exit(-1);
              }
            } 
           }
  } 
  if (err10>=0)
   {
    uscita=0;
    k41=0;
    while ((uscita!='s') && (uscita!='S') && (uscita!='n') && (uscita!='N')) 
      {
       if (k41>0) printf("\nE' stato inserito un carattere non valido.\n");
       printf("\nSi desidera creare altri file? (s/n) ");
       scanf("%s",dec71);
       getchar();
       uscita=dec71[0];
       k41++;
      }   
      
   }
 }
 printf("\n\nProgramma terminato correttamente\n");
}
